﻿using CliFx;
using CliFx.Attributes;
using CliFx.Infrastructure;
using Dapper;
using ArchiverLite.Services;

namespace ArchiverLite.Commands
{
    [Command("delete",Description = "清理旧版MES历史数据")]
    public class DeleteDataCommand : ICommand
    {

        [CommandParameter(0, Description = "数据库连接")]
        public string Connection { get; set; } = "";

        public ValueTask ExecuteAsync(IConsole console)
        {
            var print = (string text) => console.Output.WriteLine($"{DateTime.Now.ToLongTimeString()} {text}");
            if (this.Connection.Length > 0)
            {
                SqlMapper.Settings.CommandTimeout = 0;
            }

            var starMonth = DateTime.Now.AddYears(-1).ToString("yyyy") + "01";


            print($"开始清理旧版MES {starMonth}之前数据");

            Task.WaitAll(Task.Run(() =>
            {
                var service = new MesLegacyService(this.Connection);
                service.ClearOrder(starMonth);
            }), Task.Run(() =>
            {
                var service = new MesLegacyService(this.Connection);
                service.ClearOrderBlockPlan(starMonth);
            }));

            print("操作完成");

            return ValueTask.CompletedTask;
        }
    }
}
